clear all;
close all;
clc;
%%EJERCICIO 2: Complete los siguientes pasos

%%PASO 1: Lectura de secuencia de audio
S = leyendo('sample_audio');

%%SE UTILIZARAN UNICAMENTE 1000 muestras (por motivos de rendimiento)
S=S(1:1000);

%%Realizar las llamadas a las funciones utilizando la variable nbits de
%%forma que posteriormente se pueda cambiar el nmero de bits en el
%%experimento facilmente
nbits=8;

%%PASO 2: Codificacion PCM Uniforme 8 bits, valor de sobrecarga V=4
%% guardese en 'PCM8' el resultado de llamar a la funcin PCMUniforme y en
%% 'bitsPCM8' ese mismo resultado almacenado como bits (utilizando la
%% funcin getSecuenciaBits.

PCM8 = ...
bitsPCM8= ...

%%PASO 3: Completar la decodificacion de la secuencia de bits (a partir de
%%la variable 'bitsPCM8' pasar de nuevo a valores numricos (getSecuenciaNumerica
%%y decodificar con la funcin decodificaPCM. Almacenar los resultados 
%%en la variable 'decodificadoPCM8'

decodificadoPCM8 = ...
Perror= sum((decodificadoPCM8-S').^2);

disp(sprintf('\nCanal sin ruido \n\t\t==> Error de reconstruccion %10.5f', Perror));

%%PASO 4: Simulacin de una canal con ruido:
%%Generar una secuencia de bits de ruido con probabilidad 0.1 para la
%%secuencia codificada anteriormente 'bitsPCM8' aplicar el ruido y llevar a
%%cabo la decodificacion. Almacenar los resultados en la variable
%%'decodificadoPCM8Ruido'

decodificadoPCM8Ruido = ...
Perror= sum((decodificadoPCM8Ruido-S').^2);
disp(sprintf('\nCanal con ruido \n\t\t==> Error de reconstruccion %10.5f', Perror));

%%PASO 5: Llevar a cabo la simulacin de codificacin PCM ('bitsPCM8') con posterior
%%codificacion mediante cdigos convolucionales con el polinomio generador
%%proporcionado. 
%%Llevar a cabo el proceso de decodificacin mediante cdigos
%%convolucionales (n=4, k=2) y PCM Uniforme.
%%Almacenar el resultado de la decodificacin en la variable
%%'decodificadoPCM8Conv'
polGenerador = [0 1 1 0; 1 1 1 0;  1 1 0 1; 0 1 1 1];
n = 4;
k= 2;


decodificadoPCM8Conv= ...
Perror= sum((decodificadoPCM8Conv-S').^2);
disp(sprintf('\nCanal sin ruido, codificacin convolucional \n\t\t==> Error de reconstruccion %10.5f', Perror));


%%PASO 6: Repetir el experimento del paso 5 aadiendo ruido con
%%probabilidad 0.1.
%% Almacenar el resultado de la decodificacion en la variable
%% 'decodificadoPCM8ConvRuido'
polGenerador = [0 1 1 0; 1 1 1 0;  1 1 0 1; 0 1 1 1];
n = 4;
k= 2;

decodificadoPCM8ConvRuido=...
Perror= sum((decodificadoPCM8ConvRuido-S').^2);
disp(sprintf('\nCanal con ruido + codificacin convolucional \n\t\t==> Error de reconstruccion %10.5f', Perror));
