function [simbolos] = decodificaHuffman(bitsHuffman, tablaCodigos)

maximoTamanoBuffer = 30;
buffer = [];
simbolos = [];

posicionDeco=1;
while(1)
    for i=0:maximoTamanoBuffer
        posicionFinal = posicionDeco+i;
        if(posicionFinal > length(bitsHuffman))
            posibleCodigo = bitsHuffman(posicionDeco:end);
        else
            posibleCodigo = bitsHuffman(posicionDeco:posicionFinal);
        end
        
        simbolo = devolverSimboloHuffman(tablaCodigos, posibleCodigo);
        if(simbolo ~= -1) 
            simbolos = [simbolos simbolo];
            posicionDeco = posicionDeco + i;
            break;
        end
    end
    posicionDeco = posicionDeco+1;
    if simbolo == -1
        %%disp('WARNING: Maximo tamano buffer alcanzado: codigo Huffman no encontrado');
    end
    
    if(posicionDeco>length(bitsHuffman)) 
        break;
    end
end